local KeyHeld;

World_Flares = {
	5,
	6,
	3,
	2,
	7,
	1,
	4,
	8,
	0,
}

function DejaMark_OnLoad(self)
	self:RegisterEvent("PLAYER_TARGET_CHANGED");

	BINDING_HEADER_DejaMark = "DejaMark";
	BINDING_NAME_DejaMark = "Show Markers(Hold)";

	local t=DejaMarkFrame:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(DejaMarkFrame)
	t:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Background")

	local Button, Angle;
	for index = 1, 9 do -- Lua starts tables at 1 isntead of 0... so below I do lots of equating 9 to 0 as an index...
		Button = CreateFrame("Button", "DejaMarkIconButton"..index, self, "SecureActionButtonTemplate");
		Button:SetWidth(32);
		Button:SetHeight(32);
		Button:SetID(index);
		Button.Texture = Button:CreateTexture(Button:GetName().."NormalTexture", "ARTWORK");
		if(index==9)then
			Button.Texture:SetTexture("Interface\\BUTTONS\\UI-GroupLoot-Pass-Up");
		else
			Button.Texture:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons");
			SetRaidTargetIconTexture(Button.Texture, index); -- Blizzard specific function that centers sprite texture via index but doesn't include clearing all marks
		end
		Button.Texture:SetAllPoints();
		Button:RegisterForClicks("LeftButtonUp","RightButtonUp");
		-- Button:SetScript("OnClick", DejaMarkButton_OnClick);
		Button:SetScript("OnEnter", DejaMarkButton_OnEnter);
		Button:SetScript("OnLeave", DejaMarkButton_OnLeave);

		wfIndex = World_Flares[Button:GetID()]
		-- print(index, wfIndex)
		Button:SetAttribute("type","macro") -- /tm on left click, /wm on right click
		Button:SetAttribute("macrotext",'/run if SecureCmdOptionParse("[btn:1]") then SetRaidTargetIcon("target", '..index..') end\n/wm [btn:2] '..wfIndex..'\n/cwm [btn:2] '..wfIndex..'')

		if(index==9)then
			Button:SetPoint("BOTTOMRIGHT",0,0);
		elseif(index==1)then
			Button:SetPoint("TOPLEFT");
		elseif(index==2)then
			Button:SetPoint("TOP");
		elseif(index==3)then
			Button:SetPoint("TOPRIGHT");
		elseif(index==4)then
			Button:SetPoint("LEFT");
		elseif(index==5)then
			Button:SetPoint("BOTTOM");
		elseif(index==6)then
			Button:SetPoint("RIGHT");
		elseif(index==7)then
			Button:SetPoint("BOTTOMLEFT");
		elseif(index==8)then
			Button:SetPoint("CENTER");


		--   Angle = 360 / 8 * index;
		--   Button:SetPoint("CENTER", sin(Angle) * 50, cos(Angle) * 50);
		end
	end
end


function DejaMarkCanMark()
	if IsInRaid()
	and not (UnitIsGroupLeader("player"))
	and not (UnitIsGroupAssistant("player")) 
	then 
		UIErrorsFrame:AddMessage("You don't have permission to mark targets.", 1.0, 0.1, 0.1, 1.0, UIERRORS_HOLD_TIME);
		return false; 
	else
		return true; 
	end
end


function DejaMark_HotkeyPressed(keystate)
	KeyHeld = (keystate=="down")
	if KeyHeld
	and DejaMarkCanMark(true)
	then
		DejaMarkShowIcons();
	else
		DejaMarkFrame:Hide();
	end
end


function DejaMark_OnEvent(self, event)
	if(event=="PLAYER_TARGET_CHANGED")then
		if KeyHeld then
			DejaMarkShowIcons();
		end
	end
end


function DejaMarkShowIcons()
	if not UnitExists("target")or UnitIsDead("target")then
		return;
	end
	local X, Y = GetCursorPosition();
	local Scale = UIParent:GetEffectiveScale();
	DejaMarkFrame:SetPoint("CENTER", UIParent, "BOTTOMLEFT", X / Scale, Y / Scale);
	DejaMarkFrame:Show();
end


function DejaMarkButton_OnEnter(self)
	self.Texture:ClearAllPoints();
	self.Texture:SetPoint("TOPLEFT", -5, 5);
	self.Texture:SetPoint("BOTTOMRIGHT", 5, -5);
end


function DejaMarkButton_OnLeave(self)
	self.Texture:SetAllPoints();
end


-- function DejaMarkButton_OnClick(self, button, down)
-- 	PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
-- 	if (button=="LeftButton")then
-- 		SetRaidTargetIcon("target", (arg1~="RightButton")and self:GetID()or 0);
-- 	elseif (button=="RightButton")then
-- 		wfIndex = World_Flares[self:GetID()]
-- 		print(wfIndex)	
-- 	end
-- 	-- DejaMarkFrame:Hide();
-- end